require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MIPS_MUTEX_H_)) {
    eval 'sub _MIPS_MUTEX_H_ () {1;}' unless defined(&_MIPS_MUTEX_H_);
    unless(defined(&__MUTEX_PRIVATE)) {
    } else {
	if(defined(&__MUTEX_PRIVATE)) {
	    require 'machine/lock.ph';
	}
	eval 'sub __HAVE_SIMPLE_MUTEXES () {1;}' unless defined(&__HAVE_SIMPLE_MUTEXES);
	eval 'sub __HAVE_MUTEX_STUBS () {1;}' unless defined(&__HAVE_MUTEX_STUBS);
	eval 'sub __HAVE_SPIN_MUTEX_STUBS () {1;}' unless defined(&__HAVE_SPIN_MUTEX_STUBS);
	eval 'sub MUTEX_RECEIVE {
	    my($mtx) = @_;
    	    eval q( &membar_enter());
	}' unless defined(&MUTEX_RECEIVE);
	eval 'sub MUTEX_GIVE {
	    my($mtx) = @_;
    	    eval q( &membar_exit());
	}' unless defined(&MUTEX_GIVE);
	eval 'sub MUTEX_CAS {
	    my($p, $o, $n) = @_;
    	    eval q(( &atomic_cas_ulong(( &volatile \'u_long\' *)($p), ($o), ($n)) == ($o)));
	}' unless defined(&MUTEX_CAS);
    }
}
1;
