require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MIPS_RWLOCK_H_)) {
    eval 'sub _MIPS_RWLOCK_H_ () {1;}' unless defined(&_MIPS_RWLOCK_H_);
    if(defined(&__RWLOCK_PRIVATE)) {
	require 'mips/lock.ph';
	eval 'sub __HAVE_SIMPLE_RW_LOCKS () {1;}' unless defined(&__HAVE_SIMPLE_RW_LOCKS);
	eval 'sub RW_RECEIVE {
	    my($rw) = @_;
    	    eval q( &membar_enter());
	}' unless defined(&RW_RECEIVE);
	eval 'sub RW_GIVE {
	    my($rw) = @_;
    	    eval q( &membar_exit());
	}' unless defined(&RW_GIVE);
	eval 'sub RW_CAS {
	    my($p, $o, $n) = @_;
    	    eval q(( &atomic_cas_ulong(( &volatile \'u_long\' *)($p), ($o), ($n)) == ($o)));
	}' unless defined(&RW_CAS);
    }
}
1;
